//+------------------------------------------------------------------+
//|                                                    SAR_COLOR.mq4 |
//|                                                          Kalenzo |
//|                                       http://www.foreksik.prv.pl |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "http://www.foreksik.prv.pl"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Yellow
#property indicator_width1 2
#property indicator_width2 2

double sarUp[],sarDn[];//buffers
extern double Step = 0.009;//was .01
extern double Maximum = 0.1;
extern int Precision = 4;
extern bool SoundON=false;
double alertBar;
double prev;
double sar;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(0,sarUp);
   SetIndexBuffer(1,sarDn);
   SetIndexArrow(0,234);
   SetIndexArrow(1,233);
   
   IndicatorShortName("SAR COLORED");
   SetIndexLabel(0,"SAR Up Channel");
   SetIndexLabel(1,"SAR Down Channel");
   
   SetIndexDrawBegin(0,2);
   SetIndexDrawBegin(1,2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- 
  for(int i = 0; i<limit ;i++)
   {
    sar = NormalizeDouble(iSAR(Symbol(),0,Step,Maximum,i),Precision);
          if(sar >= iHigh(Symbol(),0,i))
      {
       if(prev != 1 && SoundON==true && i == 0 && Bars>alertBar)
        {
        Alert("Sar Channel Going Down on ",Symbol(),"-",Period());
        alertBar = Bars;
        prev=2;
       }
       sarUp[i] = sar;  
        if(sarUp[i+1] > 0) sarUp[i] = EMPTY_VALUE;  
         sarDn[i] = 0;
      }
    else
      {
       if(prev != 2 && SoundON==true && i == 0 && Bars>alertBar)
        {
        Alert("Sar Channel Going Up on ",Symbol(),"-",Period());
        alertBar = Bars;
        prev = 1;
        }
          sarDn[i] = sar;
         if(sarDn[i+1] > 0) sarDn[i] = EMPTY_VALUE; 
         sarUp[i] = 0;
       }
   }
 //----
   return(0);
  }
//+------------------------------------------------------------------+